3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
37 OK_TO_SKIP_PRE_REBASE
=
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
46 dotest
="$GIT_DIR"/rebase-merge
49 diffstat
=$
(git config
--bool rebase.stat
)
55 test -n "$prev_head" || die
"prev_head must be defined"
56 test -d "$dotest" || die
"$dotest directory does not exist"
58 unmerged
=$
(git ls-files
-u)
59 if test -n "$unmerged"
61 echo "You still have unmerged paths in your index"
62 echo "did you forget to use git add?"
66 cmt
=`cat "$dotest/current"`
67 if ! git diff-index
--quiet --ignore-submodules HEAD
--
69 if ! git commit
--no-verify -C "$cmt"
71 echo "Commit failed, please do not call \"git commit\""
72 echo "directly, but instead do one of the following: "
75 if test -z "$GIT_QUIET"
77 printf "Committed: %0${prec}d " $msgnum
80 if test -z "$GIT_QUIET"
82 printf "Already applied: %0${prec}d " $msgnum
85 if test -z "$GIT_QUIET"
87 git rev-list
--pretty=oneline
-1 "$cmt" |
sed -e 's/^[^ ]* //'
90 prev_head
=`git rev-parse HEAD^0`
91 # save the resulting commit so we can read-tree on it later
92 echo "$prev_head" > "$dotest/prev_head"
94 # onto the next patch:
95 msgnum
=$
(($msgnum + 1))
96 echo "$msgnum" >"$dotest/msgnum"
100 cmt
="$(cat "$dotest/cmt.
$1")"
101 echo "$cmt" > "$dotest/current"
102 hd
=$
(git rev-parse
--verify HEAD
)
103 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
104 msgnum
=$
(cat "$dotest/msgnum")
105 end
=$
(cat "$dotest/end")
106 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
107 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
108 export GITHEAD_
$cmt GITHEAD_
$hd
109 if test -n "$GIT_QUIET"
111 export GIT_MERGE_VERBOSITY
=1
113 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
117 unset GITHEAD_
$cmt GITHEAD_
$hd
125 echo "Strategy: $rv $strategy failed, try another" 1>&2
129 die
"Unknown exit code ($rv) from command:" \
130 "git-merge-$strategy $cmt^ -- HEAD $cmt"
135 move_to_original_branch
() {
136 test -z "$head_name" &&
137 head_name
="$(cat "$dotest"/head-name)" &&
138 onto
="$(cat "$dotest"/onto)" &&
139 orig_head
="$(cat "$dotest"/orig-head)"
142 message
="rebase finished: $head_name onto $onto"
143 git update-ref
-m "$message" \
144 $head_name $
(git rev-parse HEAD
) $orig_head &&
145 git symbolic-ref HEAD
$head_name ||
146 die
"Could not move back to $head_name"
152 move_to_original_branch
162 interactive_rebase
=explicit
165 -p|
--preserve-merges)
166 interactive_rebase
=implied
172 if [ "$interactive_rebase" = implied
]; then
177 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
180 run_pre_rebase_hook
() {
181 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
182 test -x "$GIT_DIR/hooks/pre-rebase"
184 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
185 die
"The pre-rebase hook refused to rebase."
189 test -f "$GIT_DIR"/rebase-apply
/applying
&&
190 die
'It looks like git-am is in progress. Cannot rebase.'
192 is_interactive
"$@" && exec git-rebase--interactive
"$@"
196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
197 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
198 die
'A rebase is in progress, try --continue, --skip or --abort.'
199 die
"No arguments given and $GIT_DIR/rebase-apply already exists."
206 OK_TO_SKIP_PRE_REBASE
=yes
209 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210 die
"No rebase in progress?"
212 git diff-files
--quiet --ignore-submodules ||
{
213 echo "You must edit all merge conflicts and then"
214 echo "mark them as resolved using git add"
219 prev_head
=$
(cat "$dotest/prev_head")
220 end
=$
(cat "$dotest/end")
221 msgnum
=$
(cat "$dotest/msgnum")
222 onto
=$
(cat "$dotest/onto")
223 GIT_QUIET
=$
(cat "$dotest/quiet")
225 while test "$msgnum" -le "$end"
233 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
234 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
235 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
236 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
237 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
238 move_to_original_branch
242 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243 die
"No rebase in progress?"
245 git
reset --hard HEAD ||
exit $?
249 prev_head
=$
(cat "$dotest/prev_head")
250 end
=$
(cat "$dotest/end")
251 msgnum
=$
(cat "$dotest/msgnum")
252 msgnum
=$
(($msgnum + 1))
253 onto
=$
(cat "$dotest/onto")
254 GIT_QUIET
=$
(cat "$dotest/quiet")
255 while test "$msgnum" -le "$end"
263 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
264 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
265 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
266 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
267 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
268 move_to_original_branch
272 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273 die
"No rebase in progress?"
278 GIT_QUIET
=$
(cat "$dotest/quiet")
279 move_to_original_branch
281 dotest
="$GIT_DIR"/rebase-apply
282 GIT_QUIET
=$
(cat "$dotest/quiet")
283 move_to_original_branch
285 git
reset --hard $
(cat "$dotest/orig-head")
290 test 2 -le "$#" || usage
294 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
297 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
298 --strateg=*|
--strategy=*|\
299 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
302 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
324 git_am_opt
="$git_am_opt -q"
329 git_am_opt
="$git_am_opt $1"
331 --whitespace=fix|
--whitespace=strip
)
337 git_am_opt
="$git_am_opt $1"
339 --committer-date-is-author-date|
--ignore-date)
340 git_am_opt
="$git_am_opt $1"
344 git_am_opt
="$git_am_opt $1"
349 -f|
--f|
--fo|
--for|
--forc|force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase)
361 test $# -gt 2 && usage
363 # Make sure we do not have $GIT_DIR/rebase-apply
364 if test -z "$do_merge"
366 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
368 rmdir "$GIT_DIR"/rebase-apply
371 It seems that I cannot create a rebase-apply directory, and
372 I wonder if you are in the middle of patch application or another
373 rebase. If that is not the case, please
374 rm -fr '"$GIT_DIR"'/rebase-apply
375 and run me again. I am stopping in case you still have something
382 die
"previous rebase directory $dotest still exists." \
383 'Try git rebase (--continue | --abort | --skip)'
387 # The tree must be really really clean.
388 if ! git update-index
--ignore-submodules --refresh > /dev
/null
; then
389 echo >&2 "cannot rebase: you have unstaged changes"
390 git
diff --name-status -r --ignore-submodules -- >&2
393 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
395 ?
*) echo >&2 "cannot rebase: your index contains uncommitted changes"
401 if test -z "$rebase_root"
403 # The upstream head must be given. Make sure it is valid.
406 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
407 die
"invalid upstream $upstream_name"
409 upstream_arg
="$upstream_name"
411 test -z "$newbase" && die
"--root must be used with --onto"
415 upstream_arg
="$root_flag"
418 # Make sure the branch to rebase onto is valid.
419 onto_name
=${newbase-"$upstream_name"}
420 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
422 # If a hook exists, give it a chance to interrupt
423 run_pre_rebase_hook
"$upstream_arg" "$@"
425 # If the branch to rebase is given, that is the branch we will rebase
426 # $branch_name -- branch being rebased, or HEAD (already detached)
427 # $orig_head -- commit object name of tip of the branch before rebasing
428 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
432 # Is it "rebase other $branchname" or "rebase other $commit"?
436 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
437 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
439 head_name
="refs/heads/$1"
440 elif branch
=$
(git rev-parse
-q --verify "$1")
442 head_name
="detached HEAD"
448 # Do not need to switch branches, we are already on it.
449 if branch_name
=`git symbolic-ref -q HEAD`
451 head_name
=$branch_name
452 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
454 head_name
="detached HEAD"
455 branch_name
=HEAD
;# detached
457 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
462 # Now we are rebasing commits $upstream..$branch (or with --root,
463 # everything leading up to $branch) on top of $onto
465 # Check if we are already based on $onto with linear history,
466 # but this should be done only when upstream and onto are the same.
467 mb
=$
(git merge-base
"$onto" "$branch")
468 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
470 ! (git rev-list
--parents "$onto"..
"$branch" |
grep " .* ") > /dev
/null
472 if test -z "$force_rebase"
474 # Lazily switch to the target branch if needed...
475 test -z "$switch_to" || git checkout
"$switch_to"
476 say
"Current branch $branch_name is up to date."
479 say
"Current branch $branch_name is up to date, rebase forced."
483 # Detach HEAD and reset the tree
484 say
"First, rewinding head to replay your work on top of it..."
485 git checkout
-q "$onto^0" || die
"could not detach HEAD"
486 git update-ref ORIG_HEAD
$branch
488 if test -n "$diffstat"
490 if test -n "$verbose"
492 echo "Changes from $mb to $onto:"
494 # We want color (if set), but no pager
495 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
498 # If the $onto is a proper descendant of the tip of the branch, then
499 # we just fast forwarded.
500 if test "$mb" = "$branch"
502 say
"Fast-forwarded $branch_name to $onto_name."
503 move_to_original_branch
507 if test -n "$rebase_root"
509 revisions
="$onto..$orig_head"
511 revisions
="$upstream..$orig_head"
514 if test -z "$do_merge"
516 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
517 $root_flag "$revisions" |
518 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
519 move_to_original_branch
521 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
522 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
523 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
524 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
525 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
529 # start doing a rebase with git-merge
530 # this is rename-aware if the recursive (default) strategy is used
533 echo "$onto" > "$dotest/onto"
534 echo "$onto_name" > "$dotest/onto_name"
536 echo "$prev_head" > "$dotest/prev_head"
537 echo "$orig_head" > "$dotest/orig-head"
538 echo "$head_name" > "$dotest/head-name"
539 echo "$GIT_QUIET" > "$dotest/quiet"
542 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
544 msgnum
=$
(($msgnum + 1))
545 echo "$cmt" > "$dotest/cmt.$msgnum"
548 echo 1 >"$dotest/msgnum"
549 echo $msgnum >"$dotest/end"
554 while test "$msgnum" -le "$end"